var serverSystem = server.registerSystem(0, 0);
var lock = 0;
KillerList = [];

serverSystem.initialize = function () {
   this.broadcastEvent("minecraft:execute_command", `/scoreboard objectives add DeathCount dummy "Death Count"`);
   this.broadcastEvent("minecraft:execute_command", `/scoreboard objectives add KillCount dummy "Kill Count"`);
   this.listenForEvent("minecraft:entity_death", (eventData) => this.deathCounter(eventData));
   this.listenForEvent("minecraft:player_attacked_actor", (eventData) => this.attacker(eventData));
}

serverSystem.update = function() {
    if (lock > 0) {
        lock = lock - 1;
    }
    if (lock === 0) {
        KillerList = [];
    }
}

serverSystem.deathCounter = function (eventData) {
    entity = eventData.entity;
    entityname = entity.__identifier__;
    if (entityname === "minecraft:player") {
        playername = this.getComponent(entity, "minecraft:nameable");
        this.broadcastEvent("minecraft:execute_command", `/scoreboard players add @a[name= ${playername.name}] DeathCount 1`);
    }
    if (lock > 0) {
        this.increaseKill();
    }
}

serverSystem.attacker = function (eventData) {
    player = eventData.player;
    killer = this.getComponent(player, "minecraft:nameable");
    KillerList.push(killer.name);
    lock = 2;

}
serverSystem.increaseKill = function() {
    this.broadcastEvent("minecraft:execute_command", `/scoreboard players add @a[name= ${KillerList[0]}] KillCount 1`);
}